#include<bits/stdc++.h>
using namespace std;

unsigned long long najv,cur;
int N;
int x_koord[1000008];
int y_koord[1000008];
int x_koord2[1000008];
int y_koord2[1000008];
int x,y;

int main(){
    scanf("%d",&N);
    for(int i=0;i<N;i++)
        scanf("%d %d",x_koord+i,y_koord+i);
    printf("0\n");
    for(int l=2;l<=N;l++){
        for(int i=0;i<l;i++){
            x_koord2[i]=x_koord[i];
            y_koord2[i]=y_koord[i];
        }
        sort(x_koord2,x_koord2+l);
        sort(y_koord2,y_koord2+l);
        najv=0;
        x=x_koord2[l/2];
        y=y_koord2[l/2];
        cur=0;
        for(int j=0;j<l;j++)
            cur+=abs(x-x_koord[j])*abs(y-y_koord[j]);
        najv=cur;
        x=x_koord2[l/2+1];
        y=y_koord2[l/2];
        cur=0;
        for(int j=0;j<l;j++)
            cur+=abs(x-x_koord[j])*abs(y-y_koord[j]);
        if(cur>najv) najv=cur;
        x=x_koord2[l/2];
        y=y_koord2[l/2+1];
        cur=0;
        for(int j=0;j<l;j++)
            cur+=abs(x-x_koord[j])*abs(y-y_koord[j]);
        if(cur>najv) najv=cur;
        x=x_koord2[l/2+1];
        y=y_koord2[l/2+1];
        cur=0;
        for(int j=0;j<l;j++)
            cur+=abs(x-x_koord[j])*abs(y-y_koord[j]);
        if(cur>najv) najv=cur;
        printf("%llu\n",cur%1000000007llu);
    }
    return 0;
}